(index)=

% This documentation tries to follow https://diataxis.fr/ (Daniele Procida)
% Other media about the same topic:
% - https://ep2018.europython.eu/media/conference/slides/get-your-documentation-right.pdf
% - https://www.youtube.com/watch?v=t4vKPhjcMZg
% - A good example: http://docs.django-cms.org/en/latest/contributing/documentation.html#contributing-documentation

% Tutorials - lessons that take the reader by the hand through a series of steps to complete a project
% (Example: kid cooking; learning-oriented)
%
% - learning by doing
% - getting started
% - inspiring confidence
% - repeatability
% - immediate sense of achievement
% - concreteness, not abstraction
% - minimum necessary explanation
% - no distractions

```{include}  ../../README.md
```

```{toctree}
:caption: Tutorials
:hidden: true
:maxdepth: 2

adc
spi_adc
```


% Explanation (Background, Discussions) - discussions that clarify and illuminate a particular topic
% (Example: history of cooking; understanding-oriented)
%
% - giving context
% - explaining why
% - multiple examples, alternative approaches
% - making connections
% - no instruction or technical description

```{toctree}
:caption: Explanation
:hidden: true
:maxdepth: 2

timing_synchronization
```

% How-To Guides - guides that take the reader through the steps required to solve a common problem
% (Example: recipe; problem-oriented)
%
% - a series of steps
% - a focus on the goal
% - addressing a specific question
% - no unnecessary explanation
% - a little flexibility
% - practical usability
% - good naming

% ```{toctree}
% :caption: How-To Guides
% :hidden: true
% :maxdepth: 2
%
% ```

% Reference - technical descriptions of the machinery and its operation
% (Example: Wikipedia pages of ingredients; information-oriented)
%
% - structure
% - consistency
% - description
% - accuracy

```{toctree}
:caption: Reference
:hidden: true
:maxdepth: 2
:name: reference

api
```
% release_notes
% license
